Subject: Re: bug#62237: 28.1 or higher: 24-bit true color breaks colours in Emacsen built without X under GNU Screen

From: Eli Zaretskii <[email-masked]>
Date: Sat, 18 Mar 2023 17:13:45 +0200

> From: Sebastian Tennant <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
> Date: Sat, 18 Mar 2023 15:01:53 +0000
> 
> I've now built and installed screen ‘master’ (4.99) and the problem is
> resolved, i.e. provided my .screenrc includes the line ‘truecolor on’,
> colours work fine with COLORTERM set to ‘truecolor’, or not set at
> all.
> 
> Sorry about all this.  Many months ago, I built screen from master and
> ran it to see if it made a difference.  I concluded then that it
> didn't and I think this must have been because I didn't actually
> install the version I built.  This meant that the relevant entries
> under /usr/lib/terminfo/s were not written/updated.
> 
> In any case, we've established one thing for certain, the version of
> screen shipped by Debian bullseye (stable) does not support truecolor.
> Most strange is the fact that, according to dpkg, the version shipped
> is 4.8.0:
> 
>  $ dpkg -l | grep screen
>  ii  screen  4.8.0-6  amd64 terminal multiplexer with VT100/ANSI…
>              ^^^^^
> 
> but screen itself reports:
> 
>  $ screen --version
>  Screen version 4.08.00 (GNU) 05-Feb-20
>                 ^^^^
> 
> which makes no sense at all!
> 
> According to:
> 
>  https://packages.debian.org/search?keywords=screen
> 
> Debian bookworm (the next stable release) will ship screen version
> 4.9.0.  I've downloaded the deb and grepped the manpage and the string
> "truecolor" is nowhere to be found so it looks as if screen shipped by
> Debian will lack support for truecolor for some years to come.

According to this:

  https://bbs.archlinux.org/viewtopic.php?id=249670

true color support in 'screen' will be released in version 5, and the
4.x branch of 'screen' doesn't support it.  This is consistent with
the fact that you built 'screen' from their mast branch, and it
announces itself as version 4.99, i.e. the development version of
v5.x.  I guess an entry in etc/PROBLEMS about this is in order.

What is still a mystery to me is why does GNOME Terminal set
COLORTERM=truecolor in the environment.  Does it assume that 'screen'
will not be used or something?  Or does GNOME itself support true
color?